<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
    <meta name="viewport" content="width=\, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <link 
     rel="stylesheet" href="https://unpkg.com/leaflet@1.9.4/dist/leaflet.css"
     integrity="sha256-p4NxAoJBhIIN+hmNHrzRCf9tD/miZyoHS5obTRR9BMY="
     crossorigin=""/>
    <script 
     src="https://unpkg.com/leaflet@1.9.4/dist/leaflet.js"
     integrity="sha256-20nQCchB9co0qIjJZRGuk2/Z9VM+kNiyxNV1lvTlZBo="
     crossorigin=""></script>
    <style>
      #issMap {
        height: 380px;
      }
    </style>

    <title>Fetch JSON from API and map lat lon</title>
  </head>
  <body>
    <h1>Where is the ISS?</h1>

    <p>
      latitude: <span id="lat"></span>°<br />
      longitude: <span id="lon"></span>°
    </p>

    <div id="issMap"></div>

    <script>
      const mymap = L.map('issMap').setView([0, 0], 1);
      const attribution =
        '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors';

      const tileUrl = 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
      const tiles = L.tileLayer(tileUrl, { attribution });
      tiles.addTo(mymap);

      const issIcon = L.icon({
        iconUrl: 'iss200.png',
        iconSize: [50, 32],
        iconAnchor: [25, 16]
      });
      const marker = L.marker([0, 0], { icon: issIcon }).addTo(mymap);

      const api_url = 'https://api.wheretheiss.at/v1/satellites/25544';

      let firstTime = true;

      async function getISS() {
        const response = await fetch(api_url);
        const data = await response.json();
        const { latitude, longitude } = data;

        marker.setLatLng([latitude, longitude]);
        if (firstTime) {
            mymap.setView([latitude, longitude], 2);
            firstTime = false;
        }
        mymap.setView([latitude, longitude], 2);

        document.getElementById('lat').textContent = latitude.toFixed(2);
        document.getElementById('lon').textContent = longitude.toFixed(2);
      }

      getISS();

      setInterval(getISS, 1000);
    </script>
  </body>
</html>